import pytest


@pytest.mark.parametrize(
    "query, expected_count",
    [
        [{}, 5029],
        [{"q": "gymnasielärare"}, 62],
        [{"q": "lärare"}, 250],
        [{"q": "C#"}, 52],
        [{"q": "c-körkort"}, 30],
        [{"q": ".net"}, 40],
        [{"q": "ci/cd"}, 32],
        [{"q": "erp-system"}, 7],
        [{"q": "tcp/ip"}, 8],
        [{"q": "cad-verktyg"}, 1],
        [{"q": "backend-utvecklare"}, 19],
        [{"q": "it-tekniker"}, 24],
        pytest.param({"q": "sjuksköterska"}, 494, marks=pytest.mark.smoke),
        [{"q": "sjuksköterskor"}, 494],
        [{"q": "körkort"}, 1070],
        [{"q": "livsmedel"}, 22],
        [{"q": "sköterska"}, 1],
        [{"q": "undersköterska"}, 126],
        [{"q": "försäkring"}, 65],
        [{"q": "kock"}, 83],
        [{"q": "uppsala"}, 123],
        [{"q": "pizzabagare"}, 19],
        [{"q": "personlig assistent"}, 196],
        [{"q": "förskollärare"}, 56],
        [{"q": "python"}, 97],
        [{"q": "barnmorska tandsköterska"}, 37],
        pytest.param({"q": "barnmorska fysioterapeut"}, 49, marks=pytest.mark.smoke),
        [{"q": "chefsbarnmorska barnmorska"}, 17],
        [{"q": "bartender"}, 4],
        [{"q": "personlig assistent +göteborg"}, 11],
        [{"q": "förskollärare"}, 56],
        [{"q": "sjuksköterska -stockholm"}, 431],
        pytest.param(
            {"municipality": ["AvNB_uwa_6n6", "oYPt_yRA_Smm"]},
            983,
            marks=pytest.mark.smoke,
        ),
        [{"municipality": "QiGt_BLu_amP"}, 61],
        [{"municipality": "PVZL_BQT_XtL", "region": "CifL_Rzy_Mku"}, 1593],
        [
            {
                "municipality": "PVZL_BQT_XtL",
                "region": "CifL_Rzy_Mku",
                "country": "i46j_HmG_v64",
            },
            4999,
        ],
        [{"region": "CifL_Rzy_Mku"}, 1227],
        [{"country": "QJgN_Zge_BzJ"}, 10],
        [{"occupation-group": "Z8ci_bBE_tmx"}, 396],
        pytest.param(
            {"occupation-field": "ASGV_zcE_bWf"},
            175,
            marks=pytest.mark.smoke,
        ),
        [{"q": "lärare", "published-after": "2019-01-16T07:29:52"}, 250],
        [{"q": "Kundtjänstmedarbetare", "sort": "pubdate-asc"}, 66],
        [
            {
                "q": "lärare",
                "published-after": "2019-01-16T07:29:52",
                "country": "i46j_HmG_v64",
                "sort": "pubdate-asc",
            },
            250,
        ],
        [{"q": "lärare", "region": ["CifL_Rzy_Mku", "CaRE_1nn_cSU"]}, 65],
        [{"q": "lärare", "region": "CifL_Rzy_Mku"}, 36],
        [{"q": "lärare", "municipality": "8deT_FRF_2SP"}, 1],
        pytest.param(
            {"employment-type": "PFZr_Syz_cUq"},
            4389,
            marks=pytest.mark.smoke,
        ),
        [{"employment-type": "kpPX_CNN_gDU"}, 4389],
        [{"employment-type": "EBhX_Qm2_8eX"}, 360],
        [{"experience": True}, 3938],
        [{"experience": False}, 1091],
        [{"remote": True}, 36],
        [{"remote": True, "municipality": "AvNB_uwa_6n6"}, 13],
        [{"remote": True, "region": "CifL_Rzy_Mku"}, 14],
        [{"remote": True, "abroad": True}, 0],
        [{"remote": True, "experience": True}, 31],
        [{"remote": True, "occupation-group": "DJh5_yyF_hEM"}, 4],
        [{"remote": True, "occupation-field": "RPTn_bxG_ExZ"}, 5],
        [{"remote": True, "q": "Stockholms Län"}, 14],
        pytest.param({"remote": True, "q": "Stockholm"}, 13, marks=pytest.mark.smoke),
        [{"remote": True, "q": "utvecklare"}, 2],
        [{"region": "90"}, 0],
        [{"region": "09"}, 32],
        [{"unspecified-sweden-workplace": True}, 135],
        [{"region": "90", "unspecified-sweden-workplace": True}, 135],
        [{"country": "219"}, 0],
        [{"region": "90", "country": "219"}, 0],
        [{"unspecified-sweden-workplace": True, "country": "-199"}, 0],
    ],
)
def test_different_searches_give_expected_number_of_hits(query, expected_count, client):
    # Act
    response = client.get("/search", query_string={**query, "limit": 0})

    # Assert
    assert response.json["total"]["value"] == expected_count
